import DS from 'ember-data';
import JSONSerializer from '@ember-data/serializer/json';
import Store from '@ember-data/store';
import { CollectionReference, DocumentReference, Firestore } from 'firebase/firestore';
interface Links {
    [key: string]: string;
}
interface ResourceHash {
    id: string;
    links: Links;
    [key: string]: string | Links | CollectionReference;
}
interface RelationshipDefinition {
    key: string;
    type: string;
    options: {
        buildReference?(db: Firestore): CollectionReference;
    };
}
interface ModelClass {
    modelName: string;
    determineRelationshipType(descriptor: {
        kind: string;
        type: string;
    }, store: Store): string;
    eachRelationship(callback: (name: string, descriptor: {
        kind: string;
        type: string;
    }) => void): void;
}
export default class CloudFirestoreSerializer extends JSONSerializer {
    extractRelationship(relationshipModelName: string, relationshipHash: DocumentReference): {
        id: string;
        type: string;
    } | {};
    extractRelationships(modelClass: ModelClass, resourceHash: ResourceHash): {};
    serializeBelongsTo(snapshot: DS.Snapshot, json: {
        [key: string]: string | null | DocumentReference;
    }, relationship: RelationshipDefinition): void;
    serialize(snapshot: DS.Snapshot, options: {}): {};
}
declare module 'ember-data/types/registries/serializer' {
    export default interface SerializerRegistry {
        'cloud-firestore-modular': CloudFirestoreSerializer;
    }
}
export {};
